/*
 Lê o estado de um botão na porta C5 e na borda de subida deste sinal inverte o estado do LED na porta D6
 
 Copyright (C) 2018 ADA-Projetos em Engenharia de Computacao

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 Guilherme Prearo
*/


#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

int main() {	
	DDRD |= (1 << DDD6); //Configura a porta D6 como saída
	DDRC &= ~(1 << DDC5); //Configura a porta C5 como entrada
	unsigned char entrada = 0; //entrada armazenará o valor lido na porta C
	unsigned char entrada_ant = 1; //entrada_ant armazenará o valor lido anteriormente na porta C
	while (1) {
		//Lógica de Borda
		entrada_ant = entrada; //Atualiza a entrada_ant
		entrada = (PINC & (1 << PINC5)); //Lê o valor novo da entrada
		//Se a entrada entá em '1' e é diferente da anterior:
		//	bordade subida! Então pisca o LED
		if (entrada > 0 && entrada_ant != entrada)
			PORTD ^= (1 << PD6);
		_delay_ms(10); //Espera um tempinho antes de efetuar a próxima leitura
	}
	return 0 ;
}

