/*
 Quando há a borda de subida de um sinal na porta D2, o LED na porta D6 inverte de estado
 
 Copyright (C) 2018 ADA-Projetos em Engenharia de Computacao

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 Guilherme Prearo
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>

//Rotina da interrupção INT0
ISR(INT0_vect) {
	SREG &= ~(0x80); //Desabilita interrupções
	PORTD ^= (1 << PD6); //Muda o estado da porta D6
	_delay_ms(300); //Debouncing
	SREG |= 0x80; //Habilita novamente as interrupções
}
int main() {
	DDRD &= ~(1 << DDD2); //Configura a porta D2 como entrada
	DDRD |= (1 << DDD6); //Configura a porta D6 como saída
	SREG |= 0x80; //Habilita interrupções
	EICRA |= 0x03; //Configura INT0 para a borda de subida do sinal
	EIMSK = 0x01; //Habilita a interrupção INT0
	while (1) {
	}
	return 0 ;
}
